-----------------------------------------------------------------------------------------------
-- Client Lua Script for GuildMotd
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- GuildMotd Module Definition
-----------------------------------------------------------------------------------------------
local GuildMotd = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function GuildMotd:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function GuildMotd:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- GuildMotd OnLoad
-----------------------------------------------------------------------------------------------
function GuildMotd:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("GuildMotd.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end


-----------------------------------------------------------------------------------------------
-- GuildMotd OnDocLoaded
------------------------------------------------------------------------------------------------
function GuildMotd:OnDocLoaded()

if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	   self.wndMain = Apollo.LoadForm(self.xmlDoc, "GuildMotdForm", nil, self)
	if self.wndMain == nil then
		Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		 --self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)

		self.timer = ApolloTimer.Create(1.0, false, "OnTimer", self)
	
		-- Do additional Addon initialization here
				self.wndMain:SetAnchorPoints(0.5, 0.3, 0.5, 0.3)
		self.wndMain:SetAnchorOffsets(-250, -150, 250, 150)
	end
end

-----------------------------------------------------------------------------------------------
-- GuildMotd Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on timer
function GuildMotd:OnTimer()
	if GameLib.GetPlayerUnit() then
	local tGuilds = GuildLib.GetGuilds()
	for k,v in pairs(tGuilds) do
		local motd = v.GetMessageOfTheDay(v)
		if motd ~= "" and motd ~= nil then 
		self.wndMain:FindChild("Gmotd"):SetText(motd)
		self.wndMain:FindChild("Title"):SetText(v.GetName(v))
		
		--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, motd)

		self.wndMain:Show(true)
		end
end
		end
end


-----------------------------------------------------------------------------------------------
-- GuildMotdForm Functions
-----------------------------------------------------------------------------------------------


---------------------------------------------------------------------------------------------------
-- NewMotdForm Functions
---------------------------------------------------------------------------------------------------

function GuildMotd:OnBtn()
self.wndMain:Show(false)
end

-----------------------------------------------------------------------------------------------
-- GuildMotd Instance
-----------------------------------------------------------------------------------------------
local GuildMotdInst = GuildMotd:new()
GuildMotdInst:Init()
